-----英文语言资源包
local M = {}
--local proxyClient = proxyClient
-----------入口函数开始
----en en-US en开头的都算作英文
function M.match(language)
--    return false
  if not language then return true end
  language = language:lower()
  if language == "zh" or language:sub(1,3) == 'zh-' then return false end  ---all except China.
  return true
end
function M.get_resouce(key)
  local val= M.resouces[key]
  if type(val) == "function" then
    val = val(M.resouces)
  end
  return val
end


-----------------入口函数结束--------------------
---为了在一个两变量内引用自己，定一个了函数。
local function ref(str,args)
 local common = require("reverseCommon")
 return common.rc_ref(str,args)
end

----资源--------------------
M.resouces = {
  ----error code message resources.
  ["NDL_CMD_EXEC_TIMEOUT"]            = "Timeout",
  ["NDL_DATA_INVALID"]                = "Data invalid",
  ["NDL_OUT_OF_MEMORY"]               = "Runout memory",
  ["NDL_PORT_UNAVIABLE"]              = "Port occupied",
  ["NDL_CMD_EXEC_OK"]                 = "Normal",
  ["NDL_WEBCLIENT_NOT_CONNECT"]       = "GUI not connected",
  ["NDL_NOT_SUPPORTED_YET"]           = "Not implementation yet",
  ["NDL_LOCAL_SERVER_NOT_CONNECTABLE"]= "Can't connect local service",
  ["NDL_USER_AUTHENTICATED_FAILED"]   = "Authentication failed",
  ["NDL_CLIENT_NOT_CONNECTED"]        = "Not connected yet",
  ["NDL_REQUEST_HTTP_SERVER_FAIELD"]  = "Request http server failed",
  ["NDL_WEBCLIENT_SESSION_FULL"]      = "Exceeding user limit.Try later",
  ["NDL_BRUTE_FORCE_DETACHED"]        = "Exceeding try times.Try later",
  ["NDL_UNAUTHORIZED_OR_ABUSE"]       = "Exceeding allowed licenses",
  ["NDL_PRIVILEGE_OUT_OF_RANGE"]      = "Not allowed.Please upgrade your account",
  ["NDL_USER_NOT_ONLINE"]             = "User offline",
  ["NDL_NO_SERVER_FOUND"]             = "No server found",
  ["NDL_NO_USERINFO_FOUND"]           = "User not exist",
  ["NDL_NO_PEER_INFO"]                = "No peer found",
  ["NDL_NO_SERVICE_RECORD"]           = "No service config",
  ["NDL_NO_UPDATE_CONFIGURE"]         = "Not update config",
  ["NDL_AUTO_UPDATE_FAILED"]          = "Update failed",
  ["NDL_SV_DL_BEGIN_UPDATE"]          = "Begin to update",
  ["NDL_JSON_PARSER_FAILED"]          = "Wrong JSON data format",
  ["NDL_SV_DL_UNZIPPING"]             = "Unzipping ...",
  ["NDL_SV_DL_UPDATING"]              = "Updating ...",
  ["NDL_UNEXPECTED_ERROR"]            = "Unexpected error occurs",
  ["NDL_NO_ALLOWED_CONNECT"]          = "Not allow to connected",
  ["NDL_NETWORK_UNREACHABLE"]         = "Internet unreachable",
  ["NDL_RECONNECT_NETWORK"]           = "Internet unreachable,will test later",
  ["NDL_DNS_RESOLVE_ERROR"]           = "DNS resolving failed",
  ["NDL_DATA_NOT_CHANGE"]             = "Data not change!",
  
  ----BEGIN OEM settings-------------
  ["common.app.name"]                 = "NIDAILI",    ---应用名称
  ["common.link.icon.ico"]            = "/images/nidaili2_32x32.ico", ---icon in ico format
  ["common.link.icon.png"]            = "/images/nidaili2_32x32.png", ---icon in png format
  ["common.link.logo.img"]            = "/images/nidaili320x117.png", ---主要logo.
  ["common.link.offical.url"]         = "http://www.nidaili.com",
  ["common.link.help.url"]            = ref("${common.link.offical.url}/doc"), ---官方文档URL。
  ["common.link.download.url"]        = ref("${common.link.offical.url}/download"),
  ["common.link.bbs"]                 = ref("${common.link.offical.url}/bbs"),
  ["common.link.vip"]                 = ref("${common.link.offical.url}/service/vip"),
  ["common.link.faq"]                 = ref("${common.link.offical.url}/doc/faqs"),
  ["common.about.info"]               = ref([[${common.app.name} can map any intranet divice's(PC,NAS,...) services to internet,include HTTP,SSH,both TCP & UDP,no matter how many NATs the network are.
                                              Just make our ${common.app.name} device can access internet and your local intrant.
                                              It's a perfact tool to IOT to remote control。${common.app.name} tunes for 3G/4G, with high reliability for almost every kinds of networks.
                                              It also provides VPN,with which you can access your intranet's everythings from outside.]]),
  ["common.contact.info"]             = "<p>PHONE：+86-1861-1711-216</p>",
  -------------------END OEM settings--------------------------------------------------------------------------
  -----oem data server setting,CAN keep 
  ["common.oem.server"]               = "http://update.nidaili.com",
  ["common.oem.uploadurl"]            = ref("${common.oem.server}/oemdata"),
  
  ----common resources.   
  ["common.language.setting.ok"]      = "Operation success!",
  ["common.title.button.help"]        = "Help",
  ["common.title.button.findpwd"]     = "Find password back",
  ["common.title.button.resetpwd"]    = "Password reset",
  ["common.title.errorcode"]          = "Error code",
  ["common.title.config.error"]       = "Configure error",
  ["common.title.close"]              = "Close",
  ["common.title.ok"]                 = "OK",
  ["common.title.select_lang"]        = "Select language",
  ["common.title.menulist"]           = "Main menu",
  ["common.title.basicinfo"]          = "Basic information",
  ["common.data.flipswitch.default"]  = {"Off","On"},
  ["common.error.data_invalid"]       = "Bad data format",
  ["common.error.not_allow_delete"]   = "Not allow delete",
  ["common.error.not_exist"]          = "Not exist",
  ["common.error.already_exist"]      = "Already exist",  
  ["common.error.data_not_exist"]     = ref("Data ${common.error.not_exist}"),  
  ["common.error.conflict"]           = "Conflict",
  ["common.error.nothing_change"]     = "Data not change",
  ["common.unkown.error.retry"]       = "Unkown error,Try later",
  ["common.unkown.error"]             = "Unkown error,Please contact us",
  ["common.text.error"]               = "error", 
  ["common.text.loading"]             = "loading ...",
  ["common.text.operation.success"]   = "operating success",
  ["common.text.operation.failed"]    = "Operating failed,code:${errorname},desc:${errormsg}.",
  ["common.text.connected"]           = "Already connected",
  ["common.text.switch.server"]       = "Switch server",
  ["common.text.operation"]           = "Operation",
  ["common.text.none"]                = "None",
  ["common.text.stop"]                = "Stop",
  ["common.text.start"]               = "Start",
  ["common.text.load"]                = "Load",
  ["common.text.loaded"]              = "Loaded",
  ["common.text.sysytem.assign"]      = "System assign",
  ["common.text.delete"]              = "Delete",
  ["common.text.add"]                 = "Add",
  ["common.text.modify"]              = "Modify",
  ["common.text.list"]                = "List",
  ["common.text.view"]                = "View",
  ["common.text.info"]                = "information",
  ["common.text.online"]              = "Online",
  ["common.text.offline"]             = "Offine",
  ["common.text.refresh"]             = "Refresh",
  ["common.text.search"]              = "Search",
  ["common.text.state"]               = "State",
  ["common.text.enabled"]             = "Enabled",
  ["common.text.disabled"]            = "Disabled",
  ["common.text.app.status"]          = "Current state",
  ["common.text.connectinfo"]         = "Connection information",
  ["common.text.runtimeinfo"]         = "Runtime information",
  ["common.text.user"]                = "User",
  ["common.text.newcreate"]           = "New created",
  ["common.text.running"]             = "Running",
  ["common.text.manage"]              = "Manage",
  ["common.text.save"]                = "Save",
  ["common.text.save&apply"]          = ref("${common.text.save}&Apply"),
  ["common.text.cancel"]              = "Cancel",
  ["common.text.router"]              = "Route",
  ["common.text.erase"]               = "Erase",
  ["common.text.back"]                = "Back",
  ["common.text.finish"]              = "Finish",
  ["common.text.duplicated"]          = "Duplicated",
  ["common.text.suffix"]              = "Suffix",
  ["common.text.prefix"]              = "Prefix",
  ["common.text.middle"]              = "Middle",
  ["common.text.alphabet"]            = "Alphabets",
  ["common.text.not_supported"]       = "Not supported",
  ["common.text.only_supported"]      = "Only supported",
  ["common.text.new"]                 = "New",
  ["common.text.old"]                 = "Old",
  ["common.text.P2P"]                 = "P2P",
  ["common.text.TURN"]                = "Relay",
  ["common.text.LCL"]                 = "Local direct",
  ["common.text.winzard"]             = "Winzard",
  ["common.text.service"]             = "Service",
  ["common.text.connect"]             = "Connect",
  ["common.text.data"]                = "Data",
  ["common.text.hide"]                = "Hide",
  ["common.text.DAY"]                 = "Day",
  ["common.text.HOUR"]                = "Hour",
  ["common.text.MINITE"]              = "Minite",
  ["common.text.SECOND"]              = "Second",
  ["common.text.BEFORE"]              = "Before",
  ["common.text.REQUIRE"]             = "Require",
  ["common.text.free"]                = "Free",
  ["common.text.password"]            = "Password",
  ["common.text.more"]                = "More",
  ["common.text.not_login"]           = "Not login yet",
  ["common.text.upgrate"]             = "Upgrate",
  ["common.text.unknown"]             = "Unkown",
  ["common.text.extent_limit"]        = ref("Exceeded limit,Pease ${common.text.upgrate} ${pserver.levels.title}"),
  ["common.title.button.restart"]     = "Restart",
  ["common.text.restart_enabled"]     = "Enabled after restart",
  ["common.text.otherside"]           = "Otherside",
  ["common.text.SERVER"]              = "Server",
  ["common.text.left"]                = "Left",
  ["common.text.same"]                = "Same",
  ["common.text.activate"]            = "Activate",
  ["common.text.version"]             = "Version",
  ["common.text.offical_website"]     = "Offical website",
  ["common.text.documentation"]       = "documentation",
  ["common.text.all"]                 = "All",
  ["common.text.NOT"]                 = "Not",
  ["common.text.other"]               = "Other",
  ["common.text.bind"]                = "Bind",
  ["common.text.unbind"]              = "Unbind",
  ["common.text.hardware"]            = "Hardware",
  ["common.text.flag"]                = "Flag",
  ["common.text.select"]              = "Select",
  ["common.text.template"]            = "Template",
  ["common.text.upload"]              = "Upload",
  ["common.text.name"]                = "Name",
  ["common.already_vlan"]             = "VPN already assembled",
  ["common.prompt.text"]              = "Are you sure to continue?",
  
  ["common.js.pager.div"]             = 'Total<b>${total}</b> items,Display to <b><span class="pageto">${pageto}</span></b>.',
  
  ["common.title.button.changelevel"] = ref("Setting-${pserver.levels.title}"),
  
  ["common.confirm_password.not_same"]= "Passwords NOT the same",
  
  ["validate.not.empty"]              = "Not allow empty",
  ["validate.str.len.min"]            = "Lengh must NOT less than",
  ["validate.str.len.max"]            = "Lengh must NOT greater than",
  ["validate.number.range"]           = "Valid length range:[${min}-${max}]",
  ["winzard.text.next"]               = "Next",
  ["winzard.text.prev"]               = "Previous",
  ["errordlg.title.info"]             = "Operation information",
  ["errordlg.title.error"]            = "Operation failed",
  ["validate.not.number"]             = "Not a numeric",
  
  ["webclient.reconnect"]             = "Session invalidation,Please re-login",
  ----template-menu.lsp--------------
  ["menu.level0.router.title"]        = "Router settings",
  ["menu.level0.services.title"]      = "Publish services",
  ["menu.level0.tservices.title"]     = "Connect services",
  ["menu.level0.pserver.title"]       = "Server settings",
  ["menu.level0.others.title"]        = "Others",
  ["menu.level1.bbs.title"]           = "BBS",
  ["menu.level1.vip.title"]           = "VIP",
  ["menu.level0.system.title"]        = "System",
  ["menu.level1.faq.title"]           = "FAQ",
  
  ---template-header.lsp resouces
  ["template-header.title.firstpage"] = "First page",
  ["template-header.title.logout"]    = "Logout",
  ["template-header.title.restart"]   = "Restart",
  ["template-header.title.changelang"]= "Languages",
  ---template-footer.lsp resources
  ["template-footer.title"]               = ref("${common.app.name}"),  ---低边显示标题。
  ["template-footer.browser.notsupport"]  = "<span style='color:red;padding-left:2px;'>Not supported web browser,Please use latest Firefox or Chrome</span>",
  ["template-footer.browser.alert"]       = "Please upgrate your web browser!",
  
    -----login.lsp
  ["login.title"]                     = "Login",
  ["login.title.confirm.register"]    = [[Wannt register a new user？( Already register use can click "Cancel" to direct login )]],
  ["login.title.open.connection"]     = "GUI not connect to service,Please re-connect.",
  ["login.title.form.username"]       = "Username",
  ["login.title.username.placeholder"]= "Please input your username",
  ["login.title.form.password"]       = "Password",
  ["login.title.password.placeholder"]= "Please input your password",
  ["login.title.button.ok"]           = "OK",  
  ["login.user.auth.failed"]          = "Username or password is not correct,Your can try {0} times again.",
  ["login.error_nointernet"]          = ref("${NDL_NETWORK_UNREACHABLE},Please try again after re-setting."),
  ---connectionsetting.lsp
  ["connectionsetting.title"]               = "Reconnect service",  
  ["connectionsetting.title.j_host"]        = "Service address",
  ["connectionsetting.placeholder.j_host"]  = "Default:127.0.0.1,Don't modify unless you know all about it!",
  ["connectionsetting.title.j_port"]        = "Port",
  ["connectionsetting.placeholder.j_port"]  = "Default:${port},Don't modify unless you know all about it!",
  ["connectionsetting.button.reconnect"]    = "Reconnect",
  ["connectionSetting.failed"]              = "Connect failed,Maybe the service is NOT start yet. Please check the netnetwork,and try again later",
  ["connectionSetting.success"]             = ref("${menu.level0.tservices.title}${common.text.operation.success},Please re-login"),
  ----index.lsp
  ["index.title"]                     = ref("${common.text.app.status}"), --"运行状态"
  ["index.text.network.failed"]       = "Internet unreachable,Please check!",
  ["index.text.status.notinit"]       = "System is initializing, Try later.",
  ["index.text.status.notok"]         = "Error occurs.Code:${errorname},Describle:${errormsg}.",
  ["index.text.status.ok.tpl"]        = "${state}&nbsp;Publish server:${servername} &nbsp;&nbsp;${switchserverlink}",
  ["index.text.switchserver"]         = "Switch server",
  ["index.title.system"]              = "System information",
  --["index.version.new"]               = '<span class="font-red"><b>Found new version</b></span>,<a href="#" onclick="updateSystem();">Update now</a>',
  --["index.version.no"]                = '<span class="font-red">Already the latest version</span>',
  ["index.text.systeminfo"]           = ref([[<p>OS：${osname} &nbsp;${runoutinfo} &nbsp;&nbsp; <a href="/pages/system/about.lsp" data-ajax="false" target="_blank">${updateinfo.title}</a> </p>
                                 <p>Username:<a href="/pages/system/adminProfile.lsp" data-ajax="false">${username}</a>
                                 &nbsp;&nbsp;Level:<span>${levelname}</span>
                                 &nbsp;<a href="${common.link.offical.url}/service/vip" data-ajax="false" target="_blank">Upgrade</a></p>]]),
  ---------运行信息------
  ["index.runtime.ttlday"]            = '<span class="emp">You VIP left:<span class="emphase ttlday font-green">0</span> days to expiration</span>',
  ["index.runtime.dataleft1"]         = '<span class="emp">High speed data left:<span class="emphase dataleft font-green d1">0</span>M</span>',
  ["index.runtime.dataleft2"]         = '<span class="emp"><span class="emphase font-red">Low speed</span> Used low speed data:<span class="emphase dataleft d2">0</span>M</span>',
  ["index.runtime.resetdatatm"]       = ref('<span class="emp">Left time to reset data counting:<span class="emphase resetdatatm">${common.text.unknown}</span></span>'),
    
  ----servers.lsp
  ["servers.title"]                   = "Servers list",
  ["servers.table.servername"]        = ref("${common.text.name}"),
  ["servers.table.domain"]            = "Domain",
  ["servers.table.desc"]              = "Describle",
  ["servers.no_more"]                 = "No more servers",

  ---listServices.lsp
  ["listServices.title"]                  = "Services manage",
  ["listServices.table.noservices"]       = "No services",
  ["listServices.table.servicedisabled"]  = "Disabled",
  ["listServices.table.statenormal"]      = "Normal",
  ["listServices.table.name"]             = ref("${serviceWinzard.service_name}"),
  ["listServices.table.localaddr"]        = "Intranet address",
  ["listServices.table.externaladdr"]     = "Internet address",
  ["listServices.table.state"]            = "State",
  ["listServices.title.listservices"]     = "Services list",
  ["listservices.popup.menu"]             = "Add service",
  ["listservices.popup.menuitembasic"]    = "Winzard(Beginer)",
  ["listservices.popup.menuitemadvance"]  = "Direct(Senior)",    
  ------editService.lsp
  ["editService.title"]                   = "Add&Modify service",
  ["editService.server.extrauser"]        = "Extra user",
  ["editService.text.change.alert"]       = "Must stop the service before you can change,Are you sure to continue?",
  ["editService.text.validate.alert"]     = "Add domain need to verify,Are you sure to conintue?",
  ["editService.service.name"]            = "Service name",
  ["editService.service.name.placeholder"]= "Name[Length range:2-20]",
  ["editService.service.type"]            = "Service type",
  ["editService.service.type.standhttp"]  = "Stand HTTP service",
  ["editService.service.type.nostandhttp"]= "None stand HTTP service",
  ["editService.service.type.nostandhttps"] = "None stand HTTPS service",
  ["editService.service.type.tcp"]          = "Common TCP service",
  ["editService.service.type.udp"]          = "Common UDP service",
  ["editService.service.type.vpn_tcp"]      = "VPN service(TCP)",
  ["editService.service.type.vpn_udp"]      = "VPN service(UDP)",
  ["editService.service.localAddr"]         = "Intranet IP",
  ["editService.service.localAddr.placeholder"]  = "Example:192.168.1.1",
  ["editService.service.localPort"]              = "Service port",
  ["editService.service.localPort.placeholder"]  = "Example:80",
  ["editService.service.extern_addr"]            = "Internet address",
  ["editService.service.extern_addr.placeholder"]= "Auto generated,Can't change",
  ["editService.service.security.switch"]        =  "Securty switch",
  ["editService.service.disabled.switch"]        =  "Disabled switch",
  ["editService.service.vpn.setting"]            =  "VPN settings",
  ["editService.service.vpn.downloadconfig"]     =  "Download configure file",
  ["editService.service.vpn.setting.vlan"]       =  "Make VPN",
  ["editService.service.domain.bind"]            =  "Bind domain",
  ["editService.domain.name"]                    =  ref("${common.text.name}"),
  ["editService.domain.ofurl"]                   =  "Offline url",
  ["editService.domain.status"]                  =  ref("${common.text.state}"),
  ["editService.domain.title"]                   =  "Domain bind",
  ["editService.domain.name.title"]              =  "Your domain",
  ["editService.domain.name.title.placeholder"]  =  "Example:[www.xxx.com]",
  ["editService.domain.ofurl.title"]             =  "Offline URL(Stand HTTP service use only)", 
  ["editService.domain.ofurl.title.placeholder"] =  "Example:[http://www.yyy.com]",
  ["editService.multi_level_domain"]             =  "Multiple levels domain",
  ["editService.error.service_running"]          =  "Service running,Can't change ${fielddesc}",
  ["editService.error.localservice_testfailed"]  =  "Connect intranet service failed,Make sure is running before publish it!",
  ["editService.error.re-pub_same_service"]      =  'intranet serice:"${localAddr}:${localPort}",already published!',
  ["editService.localservice_testok"]            =  "Test success,Congratulations!",
  ["editService.need_software"]                  =  "Need software",
  
  ----nidailVlan.lsp
  ["nidailiVlan.title"]                           = ref("${editService.service.vpn.setting.vlan}"),
  ["nidailiVlan.error.notvpn"]                    = "Not VPN service type,Can't make VPN",
  ["nidailiVlan.vlan.info.js"]                    = "User:{0},make VPN success,route information:{1}",
  ["nidailiVlan.makelan.prompt"]                  = "Waiting device to join ...",
  ["nidailiVlan.makevlan.status"]                 = "Network change,Need to reload VPN!",
  ["nidailiVlan.after.save"]                      = "Reload VPN service after Save",
  ["nidailiVlan.vlan.pt2pt"]                      = "Allow users connect each other",
  ["nidailiVlan.routetype.title"]                 = "Router most by local",
  ["nidailiVlan.routetype.title2"]                = "Router most by server",
  ["nidailiVlan.routetype.data"]                  = {[1]='Local route first',[2]='Redirect all to server'},
  ["nidailiVlan.lancheck.title"]                  = "Local router",
  ["nidailiVlan.wancheck.title"]                  = "Up-level router",
  ["nidailiVlan.vlan.info"]                       = "Network information",
  ["nidailiVlan.vlan.advance.title"]              = "Advance(VIP only)",
  ["nidailiVlan.vlan.crossroute"]                 = "Cross route",
  ["nidailiVlan.vlan.coexist"]                    = "Coexist",  
  ["nidailiVlan.vlan.manchecked"]                 = "Custom route",
  ["nidailiVlan.vlan.advance.placeholder"]        = "Wrong advance settings can cause network problems,Make sure of it before change.",  
  ["nidailiVlan.vlan.selfiechecked"]              = "Custom parameters",  
  ["nidailiVlan.makevlan.start"]                  = "Make VPN",  
  ["nidailiVlan.makevlan.error_service_not_load"] = "Service NOT loaded",  
  ["nidailiVlan.makevlan.error_not_vip"]          = "Only VIP user can support!",  
  ["nidailiVlan.makevlan.error_conflict"]         = "User:${username} route conflict",  
  ["nidailiVlan.makevlan.failed"]                 = "User:${username} request to make VPN failed,Detail info:${msg}.", 
  ["nidailiVlan.makevlan.user_forbidden"]         = "User:${username} NOT allowed to join the VPN!",
  ["nidailiVlan.error.make_config_file"]          = "Connect security service ,client need install special APP,Are you sure to continue?",
  ["nidailiVlan.status.already_vlan"]             = "Already make VPN",
  
  ----------serviceWinzard.lsp-----------
  ["serviceWinzard.title"]                        = "Publish winzard",
  ["serviceWinzard.https.not.support"]            = "Not support stand HTTPS yet",
  ["serviceWinzard.startservice"]                 = "Start service",
  ["serviceWinzard.start.failed"]                 = "Start service failed",
  ["serviceWinzard.service_type"]                 = "Select service type",
  ["serviceWinzard.service_type_1"]               = "I wannt publish my intranet website to internet.",
  ["serviceWinzard.service_type_2"]               = "I wannt publish other intranet service to internet,Such as:SSH,Remote destop ... etc.",  
  ["serviceWinzard.publish_style"]                = "Publish website stype",  
  ["serviceWinzard.publish_style_2"]              = "Doesn't matter whether the internet address has port(With port,will faster than not).",  
  ["serviceWinzard.publish_style_1"]              = "Need like normal website,without any extra port,Such as:http://www.mydomain.com",  
  ["serviceWinzard.localaddr.step"]               =  "Input your intranet service address",
  ["serviceWinzard.proto_type"]                   =  "Service protocol",
  ["serviceWinzard.localaddr"]                    =  "Intranet service IP",
  ["serviceWinzard.localaddr.placeholder"]        =  "Example:[192.168.1.1]",
  ["serviceWinzard.local_port"]                   =  "Intranet service port",
  ["serviceWinzard.local_port.placeholder"]       =  "Example:[8080]",
  ["serviceWinzard.local_web_url.step"]           =  "Intranet website URL",
  ["serviceWinzard.local_web_url"]                =  "Intranet website's first page URL",
  ["serviceWinzard.local_web_url.placeholder"]    =  "Example:[http://192.168.1.1:8080/index.php]",
  ["serviceWinzard.service_name.step"]            =  "Name service",
  ["serviceWinzard.service_name"]                 =  "Service name",
  ["serviceWinzard.service_name.placeholder"]     =  "Length range:4-20",
  ["serviceWinzard.start_after_create"]           =  "Auto load after the service created",  
  ["serviceWinzard.laststep"]                     =  "Add service finished",
  ["serviceWinzard.laststep.success"]             =  "Add service success!",
  -----------listRalms.lsp-------------------
  ["listRalms.item"]                              =   "Visitors",
  ["listRalms.title"]                             =   ref("Visitor ${common.text.manage}"),
  ["listRalms.system_user"]                       =   "System account",  
  ["listRalms.all_previlige"]                     =   "Allow all services",
  ["listRalms.item.username"]                     =   ref("${login.title.form.username}"),
  ["listRalms.item.username.placeholder"]         =   ref("${pserver.form.username.placeholder}"),
  ["listRalms.item.realName"]                     =   "Real name",
  ["listRalms.item.realName.placeholder"]         =   ref("${listRalms.item.realName}[Length range:2-20]"),
  ["listRalms.item.phone"]                        =   "Phone",
  ["listRalms.item.phone.placeholder"]            =   "[Mobile number],At least 6 numbers",
  ["listRalms.item.password"]                     =   ref("${login.title.form.password}"),
  ["listRalms.item.password.placeholder"]         =   ref("${pserver.form.password.placeholder}"),
  ["listRalms.item.confirm_password"]             =   "Confirm password",
  ["listRalms.item.confirm_password.placeholder"] =   ref("${listRalms.item.confirm_password}[ and ${login.title.form.password} are same]"),
  
  --------------/pserver/list.lsp------------
  ["pserver.summary.title"]             = "User summary",
  ["pserver.title"]                     = "User manage",
  ["pserver.query.title"]               = ref("User ${common.text.search}"),
  ["pserver.form.username"]             = ref("${login.title.form.username}"), ---引用
  ["pserver.form.username.placeholder"] = "Login name[Lengh range:6-12 alphabets]",
  ["pserver.form.password"]             = "Login password",
  ["pserver.form.password.placeholder"] = "Length range:6-20 charactors",
  ["pserver.form.email"]                = "Email",
  ["pserver.form.email.placeholder"]    = "Please input your email",
  ["pserver.form.olevel"]               = "VIP level",
  ["pserver.form.olevel.placeholder"]   = "Please input 0-10 number,0 for free,10 for topest level",
  ["pserver.allowUsers.title"]          = "Allow max users",
  ["pserver.registerUsers.title"]       = "Current register users",
  ["pserver.onlineUsers.title"]         = "Online users",
  ["pserver.overflowUsers.title"]       = "Runout usrs",
  ["pserver.list.search.title"]         = "Search condition",
  ["pserver.list.username.title"]       = ref("${login.title.form.username}"),
  ["pserver.list.muti.placeholder"]     = "Mulitple user can split by:&quot;,&quot;",
  ["pserver.list.user.state"]           = "Account state",
  ["pserver.list.runout.state"]         = "Runout state",
  ["pserver.list.runout.state_yes"]     = "Yes",
  ["pserver.list.runout.state_no"]      = "No",
  ["pserver.list.time_from"]            = "From",
  ["pserver.list.time_to"]              = "To",
  ["pserver.list.certlevel.state_no"]   = "Unauthorized",
  ["pserver.list.certlevel.state_yes"]  = "Authorized",
  
  
  -----/pserver/control.lsp--------------
  ["pserver.control.title"]             = "User control",
  ["pserver.control.level_desc_0"]      = "User level is:<b>%s</b>.",
  ["pserver.control.level_desc_1"]      = "%s&nbsp;&nbsp;Expiration:<b>%s天%s小时</b>.",
  ["pserver.control.reset_pass_prompt"] = "Rset password need user reset it's device to activated,Are you sure to continue?",
  ["pserver.control.onlineinfo"]        = [[Feedback time:<b>${time_desc}</b><br>
                                            Current State:<b>${online_desc}</b><br>
                                            Data left:<b>${dataleft}M</b><br>
                                            Version:<b>Ver${version}</b><br>
                                            OS:<b>${osname}</b><br>
                                            PeerID:<b>${peerid}</b><br>
                                            Login server:<b>${servername}</b>]],
  ["pserver.vip.ttlday"]                = "VIP days",
  ["pserver.new_password"]              = ref("${common.text.new}${common.text.password}"),
  ["pserver.new_eamil"]                 = ref("${common.text.new}Email"),
  ["pserver.control.userconfig"]        = "User config",
  ["NDL_P_CLIENT"]                      = ref("${common.app.name} service"),
  ["NDL_P_CLIENTWEB"]                   = ref("${common.app.name} GUI"),
  -----/pserver/onlineinfo.lsp
  ["pserver.onlineinfo.title"]          = "User online information",
  
  --------------/pserver/add.lsp------------
  ["pserver.add.title"]                 = "Add user",
  ["pserver.user.username"]             = ref("${login.title.form.username}"),
  ["pserver.user.password"]             = ref("${login.title.form.password}"),
  ["pserver.user.ttlday"]               = ref("${pserver.vip.ttlday}"),
  ["pserver.user.type"]                 = "User type",
  ["pserver.user.phone"]                = ref("${listRalms.item.phone}"),
  ["pserver.user.phone_placeholder"]    = ref("${listRalms.item.phone.placeholder}"),
  ["pserver.user.address"]              = "Address",
  ["pserver.user.realname"]             = ref("${listRalms.item.realName}"),
  ["pserver.user.email"]                = "Email",
  ["pserver.user.certlevel"]            = "CERT level",
  ["pserver.user.locsid"]               = "Locked server ID",
  ["pserver.user.oemid"]                = "OEM setting",
  ["pserver.user.qq"]                   = "QQ number",
  ["pserver.user.macaddr"]              = "Bind MAC address",
  ["pserver.user.memo"]                 = "Memo",
  ["pserver.user.error1"]               = ref("VIP${pserver.vip.ttlday} can'nt grerate than ${pserver.vip.ttlday}"),
  ----intelligence import dialog
  ["pserver.import.desc"]                = "Auto import",
  ["pserver.import.itype"]               = "Type",
  ["pserver.import.itype_1"]             = "Taobao address",
  ["pserver.import.content"]             = "Content",
  ["pserver.import.content_placeholder"] = "Import content",
  ["pserver.import.button"]              = "Import",
    
  -------------/pserver/edit.lsp -------------------
  ["pserver.edit.title"]                =  "Edit user",
  ["pserver.edit.reload"]               =  "Reload",
  ----peer type(@see infinite.listPeerTypes() )
  ["peer.type.node_regular"]            = "Client node",
  ["peer.type.server_http_only"]        = "Alone HTTP server",
  ["peer.type.server_offical_civil"]    = "Offical bridged server",
  ["peer.type.server_offical_oversea"]  = "Offical oversea normal server",
  ["peer.type.server_private"]          = "Private normal server",
  ["peer.type.server_managed_private"]  = "Private managed server",
  ["peer.type.server_advance_private"]  = "Private advance server",
  
  
  ------------/pserver/levels.lsp
  ["pserver.levels.title"]                  = "User level",
  ["level.level.title"]                     = "Level",
  ["level.reconnectseconds.title"]          = "Reconnect interval(Unit:Second)",
  ["level.ownerid.title"]                   = "Server's userid",
  ["level.highbandwidth.title"]             = "High speed(Unit:M/S)",
  ["level.lowbandwidth.title"]              = "Low speed(Unit:K/S)",
  ["level.perdatalimit.title"]              = "High data packet limit(Unit:M/Day)",
  ["level.calcunit.title"]                  = "Data packet unit",
  ["level.concurrencies.title"]             = "Concurrence",
  ["level.services.title"]                  = "Ports limit",
  ["level.domains.title"]                   = "Domains limit",
  ["level.privatebandwidth.title"]          = "Third node relay speed limt(Unit:K/S)",
  ["level.clients.title"]                   = "Connect clients limit",
  ["level.name.title"]                      = "Level name",
  ["level.tservices.title"]                 = "Connect service limit",
  ["level.accessclients.title"]             = "Visitors limit",
  
  ------------------/pserver/server.lsp////////////
  ["pserver.server.title"]                  = "Basic setting",
  ["pserver.server.sysdomain"]              = "System assign domain",
  ["pserver.server.servername"]             = "Server name",
  ["pserver.server.domain"]                 = "Bind domain",  
  ["pserver.server.domain_placeholder"]     = "Need domain generic resolved to CNAME: ${sysdomain}.",
  ["pserver.server.type"]                   = "Server type",  
  ["pserver.server.httpBridgeUser"]         = "HTTP bridged userid",  
  ["pserver.server.httpproxyport"]          = "Stand HTTP port",    
  ["pserver.server.portStart"]              = "Service port from", 
  ["pserver.server.portEnd"]                = "Service port to", 
  ["pserver.server.desc"]                   = "Server description", 
  
 -------------------------------/pserver/macbind.lsp////////////////////
 ["pserver.macbind.title"]                  =  "Hardware bind",
 ["pserver.macbind.services"]               =  "publish services",
 ["pserver.macbind.tservices"]              =  "Connect services",
 ["pserver.macbind.macaddr"]                =  "MAC data",
 
  -------------/pserver/execute.lsp--------------
  ["pserver.execute.title"]             = "Execute",
  ["pserver.execute.result"]            = "Execute result",
  
  -----register.lsp
  ["register.info.success"]             = "Congratulation! Register success,Please login!",
  
  ----------------tservices--------------
  -------listTServices.lsp----------------------
  ["listTServices.title"]                =  ref("${listServices.title}"),
  --------editTServices.lsp----
  ["editTService.title"]                 =  "Modify&Add connect service",
  ["editTService.domain.title"]          =  "Service domain",
  ["editTService.domain.placeholder"]    =  "Service domain(Provide by otherside,When publish service.)",
  ["editTService.autostart.title"]       =  "Auto start",
  ["editTService.access_address.title"]  =  "Access address",
  ["editTService.authorise.title"]       =  "Authorization",
  ["editTService.name.title"]            =  "Name",
  ["editTService.name.placeholder"]      =  ref("${editService.service.name.placeholder}[Auto fetch from otherside when empty]"),
  
  ----------connectNidailiVPN.lsp--------------
  ["connectNidailiVPN.title"]                = ref("AND ${common.text.otherside}${editService.service.vpn.setting.vlan}"),
  ["connectNidailiVPN.error.check_make_vlan"]= "Not-qualified to make VPN",
  ["connectNidailiVPN.error.network_changed"]= "Network changed",
  ["connectNidailiVPN.error.port_changed"]   = "Service port changed",
  ["connectNidailiVPN.error.proto_changed"]  = "Service protocol changed",
  ["connectNidailiVPN.error.user_changed"]   = "User changed",
  ["connectNidailiVPN.changelan_alert"]      = "Network changed,need reload website manually: http://{0}:{1}/login.lsp",
  ["connectNidailiVPN.suggest.changed_lan"]  = ref("${nidailiVlan.lancheck.title} conflict,Suggest change to:{0},Are you sure to continue?"),
  ["connectNidailiVPN.status.no_vlan"]       = "Not VPN yet",
  ["connectNidailiVPN.status.need_re_vlan"]  = "Need re-VPN",
  ["connectNidailiVPN.status.already_vlan"]  = "Already served as VPN server",
  ["connectNidailiVPN.title.vpn_settings"]   = "VPN route setting",
  ["connectNidailiVPN.title.routetype"]      = "Redirect all data to VPN",
  ["connectNidailiVPN.title.coexist"]        = "Coexist",
  ["connectNidailiVPN.makevlan.again"]       = "Re-VPN",
  ----tserviceWinzard.lsp-----------------
  ["tserviceWinzard.title"]                  =  ref("Connect ${common.text.winzard}"),
  ["tserviceWinzard.error.no_data"]          =  "No service found to connect.",
  ["tserviceWinzard.service_type"]           =  "Select connect style",
  ["tserviceWinzard.service_type_1"]         =  ref("Through ${common.app.name} username"),
  ["tserviceWinzard.service_type_2"]         =  ref("Through ${common.app.name}${editTService.domain.title}"),
  ["tserviceWinzard.serviceid_types"]        =  {'Default','manually'},
  ["tserviceWinzard.serviceids_manu"]        =  "Service setting",
  ["tserviceWinzard.username.placeholder"]   =  "The username and password provided by otherside,can leave emtpy if no need",
  ["tserviceWinzard.makevlan"]               =  "Quick VPN",
  ["tserviceWinzard.service_list"]           =  "Connect service setting",
  ["tserviceWinzard.error.delete_running"]   =  "Service is running,Please stop it before delete.",
  ["tserviceWinzard.makevlan.not_support"]   =  "Not support VPN under this condition.",
  ["tserviceWinzard.makevlan.success"]       =  ref("${tserviceWinzard.makevlan}${common.text.operation.success}"),
  
  --------------ddns.lsp
  ["ddns.title"]                             =   "DDNS service",
  ["ddns.title.2"]                           =   ref("${ddns.title}[DDNS service]"),
  ["ddns.info1"]                             =   [[Like oray.com,noip.com ... etc,Suit for network,which has unqiue public IP,Through your route NAT,map local service port to outside,
                                                   Example:ADSL user,DDNS can auto update domain record when public IP changed. If you wannt bind your own domain,Just CNAME to This DDNS。]],
  ["ddns.info2"]                             =   ref([[If you don't known your network or cann't or has not capability,
                                                       Please use this link <a href="/pages/services/listServices.lsp" data-ajax="false">${common.app.name}${common.text.service}</a>,
                                                       then you can publish your intranet service to internet easily。 ]]),
  ["ddns.info3"]                             =  [[<p> your DDNS domain:<a href="#">${domain}</a></p>
                                                  <p> Bind public IP:<span class="font-green"><b>${data}</b></span> 
                                                      IP isn't correct ?<a href="${common.link.offical.url}/service/suggest" target="_blank" data-ajax="false">Tell us</a>。
                                                  </p>]],
  ["ddns.test_title"]                       =   ref("${ddns.title} connective test"),
  ["ddns.test_info1"]                       =   ref("Before test，Please add one NAT mapping record at the router(Only use for test,after test,you can remove it.)，Map device's (running ${common.app.name} service) one <b>free port</b> to internet."),
  ["ddns.test.type"]                        =   ref("${serviceWinzard.proto_type}"), -- 服务协议
  ["ddns.test.localport"]                   =   "Local port",
  ["ddns.test.localport_placeholder"]       =   "Example:3456 3457.. etc,any free port.",
  ["ddns.test.remoteport"]                  =   "Mapping port",
  ["ddns.test.remoteport_placeholder"]      =   "NAT mapping port,Default are same port with local",
  
  ---------adminProfile.lsp
  ["adminProfile.title"]                    = "Account setting",
  ["adminProfile.turn_lowspeed"]            = "Low speed relay",
  ["adminProfile.turn_highspeed"]           = "High speed relay",
  ["adminProfile.contractinfo"]             = "Contact information",
  ["adminProfile.address"]                  = ref("Contact ${pserver.user.address}"),
  ["adminProfile.address.placeholder"]      = ref("Contact ${pserver.user.address}[Lengh range:2-20 charactors]"),
  ----about.lsp----
  ["about.title"]                           = "About us",
  ["updateinfo.title"]                      = ref("${common.text.version}${common.text.info}"  ),  ---版本信息
  ["webclient.version"]                     = ref("${common.text.manage}${common.text.version}:V${version} ${info}"),  ---管理版本
  ["service.version"]                       = ref("${common.text.service}${common.text.version}:V${version} ${info}"), ---服务版本
  ["update.notify.restart"]                 = "New version activated after reboot",
  ["update.notify.no-update"]               = ref("No new ${common.text.version}"),
  ["contact.title"]                         = "Contact us",
  ----onlineinfo.lsp
  ["common.data.flipswitch.onofflines"]     = {"Offline","Online"},
  -------------oem.lsp-------------------
  ["oem.title"]                             = "OEM settings",
  ["oem.username"]                          = "User account",
  ["oem.app_name"]                          = "Software name",
  ["oem.link_logo_img"]                     = "Logo(320X117,PNG)",
  ["oem.link_icon_png"]                     = "PNG(32X32,PNG)",  
  ["oem.link_icon_ico"]                     = "ICO(32X32,ICO)",
  ["oem.about_info"]                        = "About information",
  ["oem.contact_info"]                      = "Contact information", 
  ["oem.link_offical_url"]                  = "Offical link",
  ["oem.link_help_url"]                     = "Help link",
  ["oem.link_download_url"]                 = "Download link",
  ["oem.link_bbs"]                          = "BBS link",
  ["oem.link_vip"]                          = "VIP service",
  ["oem.link_faq"]                          = "FAQ",
  ["oem.upload_error"]                      = "Upload OEM data failed",
  ["oem.testconfirm"]                       = "OEM setting success,Are you sure to activated it now?",
  ------------settings.lsp
  ["settings.title"]                        = "System configure",
  ["settings.Webclient_listening_ports"]    = "GUI listen port",
  ["settings.Peer_port"]                    = "Service listen port",
  ["settings.advance_setting"]              = "Advance setting",
  ["settings.configname"]                   = "configure key",
  ["settings.configvalue"]                  = "configure value",
  ["settings.configtype"]                   = "configure type",
  ["settings.types"]                        = {"GUI","SERVICE"},
  ["settings.getconfigure"]                 = "Get the configure",
  ["settings.setconfigure"]                 = "Setting the configure",
  
  ---------router--------------------
  ---------reboot.lsp------------
  ["router.rstatus.title"]                  = "Network status",
  ["router.wan.title"]                      = "WAN setting",
  ["router.lan.title"]                      = "LAN setting",
  ["router.reboot.title"]                   = "Reboot setting",
  ["router.reboot_now"]                     = "Reboot now",
  ["router.reboot_enabled"]                 = ref("${editService.service.disabled.switch}"),
  ["router.env_notsupported"]               = "Not support under this condition!",
  ["router.wait_reboot"]                    = "Please wait 5 minutes before operate again!",
  ----------wifi.lsp-----------
  ["router.wifi.title"]                     = "WIFI setting",
  ["router.wifi_disabled"]                  = ref("${common.text.disabled}"),
  ["router.wifi_ssid"]                      = ref("${common.text.name}"),
  ["router.wifi_key"]                       = ref("${common.text.password}"),
  ["wifi.disabled_flipswitch"]              = {"Enabled","Disabled"},
  
  ----------------node 节点管理 --------------------
  ["menu.level0.node.title"]                = "Node list",
  ["node.list.title"]                       = "Node manage",
  ["node.execute.title"]                    = ref("${pserver.execute.title}"),
  ["node.ip.title"]                         = "IP",
}

return M