-----中文语言资源包
local M = {}
--local proxyClient = proxyClient
-----------入口函数开始
----支持中文语言
----zh zh-cn zh开头的都算作中文
function M.match(language)
--    return true  ---just for test.
  if not language then return false end
  language = language:lower()
  if language == "zh" or language:sub(1,3) == 'zh-' then return true end
  return false
end
---根据key查找资源
function M.get_resouce(key)
  local val= M.resouces[key]
  if type(val) == "function" then ---说明引用了其它的key
    val = val(M.resouces)
  end
  return val
end
-----------------入口函数结束--------------------
---为了在一个两变量内引用自己，定一个了函数。
local function ref(str,args)
 local common = require("reverseCommon")
 return common.rc_ref(str,args)
end

----资源--------------------
M.resouces = {
  ----error code message resources.
  ["NDL_CMD_EXEC_TIMEOUT"]            = "等待超时",
  ["NDL_DATA_INVALID"]                = "数据不合法",
  ["NDL_OUT_OF_MEMORY"]               = "内存不足",
  ["NDL_PORT_UNAVIABLE"]              = "端口已经占用",
  ["NDL_CMD_EXEC_OK"]                 = "状态正常",
  ["NDL_WEBCLIENT_NOT_CONNECT"]       = "登录状态失效",
  ["NDL_NOT_SUPPORTED_YET"]           = "功能不支持",
  ["NDL_LOCAL_SERVER_NOT_CONNECTABLE"]= "不能连接到本地服务",
  ["NDL_USER_AUTHENTICATED_FAILED"]   = "用户认证失败",
  ["NDL_CLIENT_NOT_CONNECTED"]        = "没有连接上服务器",
  ["NDL_REQUEST_HTTP_SERVER_FAIELD"]  = "连接HTTP服务失败",
  ["NDL_WEBCLIENT_SESSION_FULL"]      = "超出用户限制,请稍后再操作",
  ["NDL_BRUTE_FORCE_DETACHED"]        = "超过允许的登录错误次数,请稍后再操作",
  ["NDL_UNAUTHORIZED_OR_ABUSE"]       = "超出允许的使用许可",
  ["NDL_PRIVILEGE_OUT_OF_RANGE"]      = "超过许可范围,请升级您的账号",
  ["NDL_USER_NOT_ONLINE"]             = "用户不在线",
  ["NDL_NO_SERVER_FOUND"]             = "没找到服务器",
  ["NDL_NO_USERINFO_FOUND"]           = "用户不存在",
  ["NDL_NO_PEER_INFO"]                = "服务节点不存在",
  ["NDL_NO_SERVICE_RECORD"]           = "服务不存在",
  ["NDL_NO_UPDATE_CONFIGURE"]         = "禁止自动更新",
  ["NDL_AUTO_UPDATE_FAILED"]          = "更新失败",
  ["NDL_SV_DL_BEGIN_UPDATE"]          = "正在更新...",
  ["NDL_JSON_PARSER_FAILED"]          = "错误数据格式[JSON]",
  ["NDL_SV_DL_UNZIPPING"]             = "解压文件中...",
  ["NDL_SV_DL_UPDATING"]              = "更新中...",
  ["NDL_UNEXPECTED_ERROR"]            = "捕获意外错误",
  ["NDL_NO_ALLOWED_CONNECT"]          = "不允许连接",
  ["NDL_NETWORK_UNREACHABLE"]         = "不能连接互联网",
  ["NDL_RECONNECT_NETWORK"]           = "连接互联网失败,稍后重试",
  ["NDL_DNS_RESOLVE_ERROR"]           = "域名解析失败",
  ["NDL_DATA_NOT_CHANGE"]             = "配置相同!",
  
  ----BEGIN OEM settings-------------
  ["common.app.name"]                 = "逆代理",    ---应用名称
  ["common.link.icon.ico"]            = "/images/nidaili2_32x32.ico", ---icon in ico format
  ["common.link.icon.png"]            = "/images/nidaili2_32x32.png", ---icon in png format
  ["common.link.logo.img"]            = "/images/nidaili320x117.png", ---主要logo.
  ["common.link.offical.url"]         = "http://www.nidaili.com",
  ["common.link.help.url"]            = ref("${common.link.offical.url}/doc"), ---官方文档URL。
  ["common.link.download.url"]        = ref("${common.link.offical.url}/download"),
  ["common.link.bbs"]                 = ref("${common.link.offical.url}/bbs"),
  ["common.link.vip"]                 = ref("${common.link.offical.url}/service/vip"),
  ["common.link.faq"]                 = ref("${common.link.offical.url}/doc/faqs"),
  ["common.about.info"]               = ref([[${common.app.name}可把任何可上网的设备变为服务器,无论设备 是在内网、外网还是小区宽带,无论经过多少级路由,
                                              只要能上网都可以，是物联网进行远程控制的理想工具。${common.app.name}专门对WIFI和3G/4G网络进行了优化，
                                              即使高延迟、高丢包率的网络条件也能稳定运行,支持断电重连、断网重试功能，确保实时在线。]]),
  
  ["common.contact.info"]             = "<p>电&nbsp;&nbsp;&nbsp;&nbsp;话：010-59741697</p><p>会员热线：1861-1711-216</p>",
  -------------------END OEM settings--------------------------------------------------------------------------
  -----oem data server setting,CAN keep 
  ["common.oem.server"]               = "http://update.nidaili.com",
  ["common.oem.uploadurl"]            = ref("${common.oem.server}/oemdata"),
  
  ----common resources.   
  ["common.language.setting.ok"]      = "设置成功!",
  ["common.title.button.help"]        = "帮助",
  ["common.title.button.findpwd"]     = "找回密码",
  ["common.title.button.resetpwd"]    = "密码重置",
  ["common.title.errorcode"]          = "错误代码",
  ["common.title.config.error"]       = "配置错误",
  ["common.title.close"]              = "关 闭",
  ["common.title.ok"]                 = "确 定",
  ["common.title.select_lang"]        = "选择语言",
  ["common.title.menulist"]           = "功能菜单",
  ["common.title.basicinfo"]          = "基本信息",
  ["common.data.flipswitch.default"]  = {"关闭","开启"},
  ["common.error.data_invalid"]       = "格式不正确",
  ["common.error.not_allow_delete"]   = "不能删除",
  ["common.error.not_exist"]          = "不存在",
  ["common.error.already_exist"]      = "已经存在",  
  ["common.error.data_not_exist"]     = ref("数据${common.error.not_exist}"),  
  ["common.error.conflict"]           = "冲突",
  ["common.error.nothing_change"]     = "数据未变化",
  ["common.unkown.error.retry"]       = "未知错误,请重试.",
  ["common.unkown.error"]             = "未知错误,联系服务商.",
  ["common.text.error"]               = "错误", 
  ["common.text.loading"]             = "加载中,请稍后...",
  ["common.text.operation.success"]   = "操作成功.",
  ["common.text.operation.failed"]    = "操作失败,错误名称:${errorname},描述:${errormsg}.",
  ["common.text.connected"]           = "已经连接",
  ["common.text.switch.server"]       = "切换服务器",
  ["common.text.operation"]           = "操作",
  ["common.text.none"]                = "无",
  ["common.text.stop"]                = "停止",
  ["common.text.start"]               = "启动",
  ["common.text.load"]                = "加载",
  ["common.text.loaded"]              = "已加载",
  ["common.text.sysytem.assign"]      = "系统分配",
  ["common.text.delete"]              = "删除",
  ["common.text.add"]                 = "添加",
  ["common.text.modify"]              = "修改",
  ["common.text.list"]                = "列表",
  ["common.text.view"]                = "查看",
  ["common.text.info"]                = "信息",
  ["common.text.online"]              = "在线",
  ["common.text.offline"]             = "离线",
  ["common.text.refresh"]             = "刷新",
  ["common.text.search"]              = "查找",
  ["common.text.state"]               = "状态",
  ["common.text.enabled"]             = "启用",
  ["common.text.disabled"]            = "禁用",
  ["common.text.app.status"]          = "运行状态",
  ["common.text.connectinfo"]         = "连接信息",
  ["common.text.runtimeinfo"]         = "实时信息",
  ["common.text.user"]                = "用户",
  ["common.text.newcreate"]           = "新添加",
  ["common.text.running"]             = "运行中",
  ["common.text.manage"]              = "管理",
  ["common.text.save"]                = "保存",
  ["common.text.save&apply"]          = ref("${common.text.save}&应用"),
  ["common.text.cancel"]              = "取消",
  ["common.text.router"]              = "路由",
  ["common.text.erase"]               = "清除",
  ["common.text.back"]                = "返回",
  ["common.text.finish"]              = "结束",
  ["common.text.duplicated"]          = "重复",
  ["common.text.suffix"]              = "后缀",
  ["common.text.prefix"]              = "前缀",
  ["common.text.middle"]              = "中间",
  ["common.text.alphabet"]            = "字母和数字",
  ["common.text.not_supported"]       = "不支持",
  ["common.text.only_supported"]      = "仅支持",
  ["common.text.new"]                 = "新的",
  ["common.text.old"]                 = "旧的",
  ["common.text.P2P"]                 = "点对点",
  ["common.text.TURN"]                = "中继传输",
  ["common.text.LCL"]                 = "局域网直连",
  ["common.text.winzard"]             = "向导",
  ["common.text.service"]             = "服务",
  ["common.text.connect"]             = "连接",
  ["common.text.data"]                = "数据",
  ["common.text.hide"]                = "隐藏",
  ["common.text.DAY"]                 =  "天",
  ["common.text.HOUR"]                =  "小时",
  ["common.text.MINITE"]              =  "分钟",
  ["common.text.SECOND"]              =  "秒",
  ["common.text.BEFORE"]              =  "前",
  ["common.text.REQUIRE"]             =  "要求",
  ["common.text.free"]                =  "免费",
  ["common.text.password"]            =  "密码",
  ["common.text.more"]                =  "更多",
  ["common.text.not_login"]           = "用户没有登录",
  ["common.text.upgrate"]             = "升级",
  ["common.text.unknown"]             = "未知",
  ["common.text.extent_limit"]        = ref("数量已经超出,请${common.text.upgrate}${pserver.levels.title}"),
  ["common.title.button.restart"]     = "重启",
  ["common.text.restart_enabled"]     = "重启后生效",
  ["common.text.otherside"]           = "对方",
  ["common.text.SERVER"]              = "服务器",
  ["common.text.left"]                = "剩余",
  ["common.text.same"]                = "相同",
  ["common.text.activate"]            = "开通",
  ["common.text.version"]             = "版本",
  ["common.text.offical_website"]     = "官网网站",
  ["common.text.documentation"]       = "文档",
  ["common.text.all"]                 = "所有",
  ["common.text.NOT"]                 = "非",
  ["common.text.other"]               = "其它",
  ["common.text.bind"]                = "绑定",
  ["common.text.unbind"]              = "解绑",
  ["common.text.hardware"]            = "硬件",
  ["common.text.flag"]                = "标识",
  ["common.text.select"]              = "选择",
  ["common.text.template"]            = "模板",
  ["common.text.upload"]              = "上传",
  ["common.text.name"]                = "名称",
  ["common.already_vlan"]             = "已经组网",
  ["common.prompt.text"]              = "要确认继续操作吗?",
  
  ["common.js.pager.div"]             = '共<b>${total}</b>条记录,显示到第<b><span class="pageto">${pageto}</span></b>条.',
  
  ["common.title.button.changelevel"] = ref("设置${pserver.levels.title}"),
  
  ["common.confirm_password.not_same"]= "两次密码不一致",
  
  ["validate.not.empty"]              = "不能为空",
  ["validate.str.len.min"]            = "长度不能小于",
  ["validate.str.len.max"]            = "长度不能大于",
  ["validate.number.range"]           = "要求数值范围:[${min}-${max}]",
  ["winzard.text.next"]               = "下一步",
  ["winzard.text.prev"]               = "上一步",
  ["errordlg.title.info"]             = "操作提示",
  ["errordlg.title.error"]            = "操作失败",
  ["validate.not.number"]             = "不是数字",
  
  ["webclient.reconnect"]             = "登录超时,刷新后请重新登录.",
  ----template-menu.lsp--------------
  ["menu.level0.router.title"]        = "路由设置",
  ["menu.level0.services.title"]      = "发布服务",
  ["menu.level0.tservices.title"]     = "连接服务",
  ["menu.level0.pserver.title"]       = "服务器设置",
  ["menu.level0.others.title"]        = "附加功能",
  ["menu.level1.bbs.title"]           = "论坛社区",
  ["menu.level1.vip.title"]           = "VIP服务",
  ["menu.level0.system.title"]        = "系统信息",
  ["menu.level1.faq.title"]           = "常见问题",
  
  ---template-header.lsp resouces
  ["template-header.title.firstpage"] = "首页",
  ["template-header.title.logout"]    = "登出",
  ["template-header.title.restart"]   = "重启",
  ["template-header.title.changelang"]= "多语言",
  ---template-footer.lsp resources
  ["template-footer.title"]               = ref("${common.app.name}服务"),  ---低边显示标题。
  ["template-footer.browser.notsupport"]  = "<span style='color:red;padding-left:2px;'>此浏览器不支持,请使用Firefox或Chrome最新版.</span>",
  ["template-footer.browser.alert"]       = "您使用的浏览器版本过低！",
  
    -----login.lsp
  ["login.title"]                     = "用户登录",
  ["login.title.confirm.register"]    = [[要注册一个用户吗？(已注册点"取消"可直接登录)]],
  ["login.title.open.connection"]     = "没有连接上后台服务,请重新连接。",
  ["login.title.form.username"]       = "用户名",
  ["login.title.username.placeholder"]= "请输入登录名",
  ["login.title.form.password"]       = "密  码",
  ["login.title.password.placeholder"]= "请输入密码",
  ["login.title.button.ok"]           = "确定",  
  ["login.user.auth.failed"]          = "用户名或者密码不正确,还有{0}次可尝试",
  ["login.error_nointernet"]          = ref("${NDL_NETWORK_UNREACHABLE},请设置好后再登录."),
  ---connectionsetting.lsp
  ["connectionsetting.title"]               = "重连服务",  
  ["connectionsetting.title.j_host"]        = "服务地址",
  ["connectionsetting.placeholder.j_host"]  = "默认是:127.0.0.1,不了解勿改!",
  ["connectionsetting.title.j_port"]        = "端口号",
  ["connectionsetting.placeholder.j_port"]  = "默认是:${port},不了解勿改!",
  ["connectionsetting.button.reconnect"]    = "重新连接",
  ["connectionSetting.failed"]              = "连接失败,可能服务未启动,请检查后重试.",
  ["connectionSetting.success"]             = ref("${menu.level0.tservices.title}${common.text.operation.success},请重新登录."),
  ----index.lsp
  ["index.title"]                     = ref("${common.text.app.status}"), --"运行状态"
  ["index.text.network.failed"]       = "互联网不通,请检查!",
  ["index.text.status.notinit"]       = "正在初始化,稍后刷新.",
  ["index.text.status.notok"]         = "状态异常.代码:${errorname},描述:${errormsg}.",
  ["index.text.status.ok.tpl"]        = "${state}&nbsp;发布服务器:${servername} &nbsp;&nbsp;${switchserverlink}",
  ["index.text.switchserver"]         = "切换服务器",
  ["index.title.system"]              = "系统情况",
  --["index.version.new"]               = '<span class="font-red"><b>发现新版本</b></span>,<a href="#" onclick="updateSystem();">立即更新</a>',
  --["index.version.no"]                = '<span class="font-red">已为最新版</span>',
  ["index.text.systeminfo"]           = ref([[<p>操作系统：${osname} &nbsp;${runoutinfo} &nbsp;&nbsp; <a href="/pages/system/about.lsp" data-ajax="false" target="_blank">${updateinfo.title}</a> </p>
                                 <p>用户名：<a href="/pages/system/adminProfile.lsp" data-ajax="false">${username}</a>
                                 &nbsp;&nbsp;级别：<span>${levelname}</span>
                                 &nbsp;<a href="${common.link.offical.url}/service/vip" data-ajax="false" target="_blank">升级</a></p>]]),
  ---------运行信息------
  ["index.runtime.ttlday"]            = '<span class="emp">您还有:<span class="emphase ttlday font-green">0</span>天VIP服务到期</span>',
  ["index.runtime.dataleft1"]         = '<span class="emp">高速流量还有:<span class="emphase dataleft font-green d1">0</span>兆</span>',
  ["index.runtime.dataleft2"]         = '<span class="emp"><span class="emphase font-red">低速模式</span>已用低速流量:<span class="emphase dataleft d2">0</span>M</span>',
  ["index.runtime.resetdatatm"]       = ref('<span class="emp">距流量重置时间:<span class="emphase resetdatatm">${common.text.unknown}</span></span>'),
    
  ----servers.lsp
  ["servers.title"]                   = "服务器列表",
  ["servers.table.servername"]        = ref("${common.text.name}"),
  ["servers.table.domain"]            = "域名",
  ["servers.table.desc"]              = "描述",
  ["servers.no_more"]                 = "无更多服务器",

  ---listServices.lsp
  ["listServices.title"]                  = "服务管理",
  ["listServices.table.noservices"]       = "没有设置服务",
  ["listServices.table.servicedisabled"]  = "未启用",
  ["listServices.table.statenormal"]      = "正常",
  ["listServices.table.name"]             = ref("${serviceWinzard.service_name}"),
  ["listServices.table.localaddr"]        = "内网设置",
  ["listServices.table.externaladdr"]     = "外网地址",
  ["listServices.table.state"]            = "状  态",
  ["listServices.title.listservices"]     = "服务列表",
  ["listservices.popup.menu"]             = "添加服务",
  ["listservices.popup.menuitembasic"]    = "向导添加(初级)",
  ["listservices.popup.menuitemadvance"]  = "直接添加(高级)",    
  ------editService.lsp
  ["editService.title"]                   = "修改/添加服务",
  ["editService.server.extrauser"]        = "额外访问者",
  ["editService.text.change.alert"]       = "必须要停止该服务运行才能改变此值,您确定停止服务吗？",
  ["editService.text.validate.alert"]     = "添加自定义域名需要进行认证,要进行吗？",
  ["editService.service.name"]            = "服务名称",
  ["editService.service.name.placeholder"]= "名称[可输入2-20个汉字]",
  ["editService.service.type"]            = "服务类型",
  ["editService.service.type.standhttp"]  = "标准HTTP服务",
  ["editService.service.type.nostandhttp"]= "非标准HTTP服务",
  ["editService.service.type.nostandhttps"] = "非标准HTTPS服务",
  ["editService.service.type.tcp"]          = "自定义TCP服务",
  ["editService.service.type.udp"]          = "自定义UDP服务",
  ["editService.service.type.vpn_tcp"]      = "VPN服务(TCP)",
  ["editService.service.type.vpn_udp"]      = "VPN服务(UDP)",
  ["editService.service.localAddr"]         = "本地IP地址",
  ["editService.service.localAddr.placeholder"]  = "例如:192.168.1.1",
  ["editService.service.localPort"]              = "本地服务端口",
  ["editService.service.localPort.placeholder"]  = "例如:80",
  ["editService.service.extern_addr"]            = "外网访问地址",
  ["editService.service.extern_addr.placeholder"]= "系统自动生成，不要填写",
  ["editService.service.security.switch"]        =  "安全控制",
  ["editService.service.disabled.switch"]        =  "是否启用",
  ["editService.service.vpn.setting"]            =  "VPN设置",
  ["editService.service.vpn.downloadconfig"]     =  "下载客户端配置文件",
  ["editService.service.vpn.setting.vlan"]       =  "虚拟组网",
  ["editService.service.domain.bind"]            =  "绑定的域名",
  ["editService.domain.name"]                    =  ref("${common.text.name}"),
  ["editService.domain.ofurl"]                   =  "离线地址",
  ["editService.domain.status"]                  =  ref("${common.text.state}"),
  ["editService.domain.title"]                   =  "域名绑定",
  ["editService.domain.name.title"]              =  "您绑定的域名",
  ["editService.domain.name.title.placeholder"]  =  "例如:[www.xxx.com]",
  ["editService.domain.ofurl.title"]             =  "离线URL(仅对HTTP服务有效)", 
  ["editService.domain.ofurl.title.placeholder"] =  "例如:[http://www.yyy.com],仅对HTTP类型服务有效",
  ["editService.multi_level_domain"]             =  "多级域名",
  ["editService.error.service_running"]          =  "服务运行中,${fielddesc}不能修改!",
  ["editService.error.localservice_testfailed"]  =  "连接本地服务失败,发布前请确保本地服务端口监听中.",
  ["editService.error.re-pub_same_service"]      =  '本地服务:"${localAddr}:${localPort}",已经发布,不能重复发布!',
  ["editService.localservice_testok"]            =  "恭喜,测试成功。",
  ["editService.need_software"]                  =  "需下载软件",
  
  ----nidailVlan.lsp
  ["nidailiVlan.title"]                           = ref("${editService.service.vpn.setting.vlan}"),
  ["nidailiVlan.error.notvpn"]                    = "不是VPN服务,不能组网",
  ["nidailiVlan.vlan.info.js"]                    = "用户:{0},组网成功,路由信息:{1}",
  ["nidailiVlan.makelan.prompt"]                  = "等待设备加入组网中...",
  ["nidailiVlan.makevlan.status"]                 = "网络已变化,需重新加载VPN配置!",
  ["nidailiVlan.after.save"]                      = "保存后重新加载VPN服务",
  ["nidailiVlan.vlan.pt2pt"]                      = "允许用户之间互相联通",
  ["nidailiVlan.routetype.title"]                 = "客户端路由",
  ["nidailiVlan.routetype.title2"]                = "服务端路由",
  ["nidailiVlan.routetype.data"]                  = {[1]='客户端优先',[2]='重定向到服务端'},
  ["nidailiVlan.lancheck.title"]                  = "本级路由",
  ["nidailiVlan.wancheck.title"]                  = "上级路由",
  ["nidailiVlan.vlan.info"]                       = "组网信息",
  ["nidailiVlan.vlan.advance.title"]              = "高级设置(VIP用户)",
  ["nidailiVlan.vlan.crossroute"]                 = "允许反向通讯",
  ["nidailiVlan.vlan.coexist"]                    = "多个服务共存",  
  ["nidailiVlan.vlan.manchecked"]                 = "自定义路由",
  ["nidailiVlan.vlan.advance.placeholder"]        = "高级配置,错误的配置会导致运行错误",  
  ["nidailiVlan.vlan.selfiechecked"]              = "自定义配置参数",  
  ["nidailiVlan.makevlan.start"]                  = "组网",  
  ["nidailiVlan.makevlan.error_service_not_load"] = "服务未加载",  
  ["nidailiVlan.makevlan.error_not_vip"]          = "VIP用户才支持进行高级设置!",  
  ["nidailiVlan.makevlan.error_conflict"]         = "用户:${username}路由冲突",  
  ["nidailiVlan.makevlan.failed"]                 = "用户:${username}请求组网失败,详情:${msg}.", 
  ["nidailiVlan.makevlan.user_forbidden"]         = "用户:${username}被禁止组网!",
  ["nidailiVlan.error.make_config_file"]          = "连接安全认证服务,需要按照专用客户端才行,要继续吗?",
  ["nidailiVlan.status.already_vlan"]             = "已经和其它设备组网了",
  
  ----------serviceWinzard.lsp-----------
  ["serviceWinzard.title"]                        = "发布向导",
  ["serviceWinzard.https.not.support"]            = "暂不支持不带端口的https代理",
  ["serviceWinzard.startservice"]                 = "启动服务",
  ["serviceWinzard.start.failed"]                 = "启动失败,错误原因",
  ["serviceWinzard.service_type"]                 = "选择服务类型",
  ["serviceWinzard.service_type_1"]               = "我想把内网网站发布到外网",
  ["serviceWinzard.service_type_2"]               = "我想把其它内网服务发布到外网<br/>包括:远程控制,视频监控,远程访问数据库等",  
  ["serviceWinzard.publish_style"]                = "发布网站方式选择",  
  ["serviceWinzard.publish_style_2"]              = "网址带端口号无所谓,外网能访问就行<br/>[带端口的网站速度会快点哈,原因不解释:)]",  
  ["serviceWinzard.publish_style_1"]              = "我希望网站地址不带端口号<br/>像访问百度,新浪一样",  
  ["serviceWinzard.localaddr.step"]               =  "输入内网服务地址",
  ["serviceWinzard.proto_type"]                   =  "服务协议",
  ["serviceWinzard.localaddr"]                    =  "内网服务IP地址",
  ["serviceWinzard.localaddr.placeholder"]        =  "例如:[192.168.1.1]",
  ["serviceWinzard.local_port"]                   =  "内网服务端口号",
  ["serviceWinzard.local_port.placeholder"]       =  "例如:[8080]",
  ["serviceWinzard.local_web_url.step"]           =  "内部网站地址",
  ["serviceWinzard.local_web_url"]                =  "内部网站首页地址",
  ["serviceWinzard.local_web_url.placeholder"]    =  "例如:[http://192.168.1.1:8080/index.php]",
  ["serviceWinzard.service_name.step"]            =  "设置服务名称",
  ["serviceWinzard.service_name"]                 =  "服务名称",
  ["serviceWinzard.service_name.placeholder"]     =  "任意输入4-20个字符",
  ["serviceWinzard.start_after_create"]           =  "创建后立即加载",  
  ["serviceWinzard.laststep"]                     =  "添加服务完成",
  ["serviceWinzard.laststep.success"]             =  "添加服务成功!",
  -----------listRalms.lsp-------------------
  ["listRalms.item"]                              =   "访问者",
  ["listRalms.title"]                             =   ref("访问者${common.text.manage}"),
  ["listRalms.system_user"]                       =   "系统帐号",  
  ["listRalms.all_previlige"]                     =   "可访问所有服务",
  ["listRalms.item.username"]                     =   ref("${login.title.form.username}"),
  ["listRalms.item.username.placeholder"]         =   ref("${pserver.form.username.placeholder}"),
  ["listRalms.item.realName"]                     =   "真实名字",
  ["listRalms.item.realName.placeholder"]         =   ref("${listRalms.item.realName}[可输入2-20个汉字]"),
  ["listRalms.item.phone"]                        =   "电 话",
  ["listRalms.item.phone.placeholder"]            =   "联系电话[手机或者固定电话],要求至少6位数字",
  ["listRalms.item.password"]                     =   ref("${login.title.form.password}"),
  ["listRalms.item.password.placeholder"]         =   ref("${pserver.form.password.placeholder}"),
  ["listRalms.item.confirm_password"]             =   "确认密码",
  ["listRalms.item.confirm_password.placeholder"] =   ref("${listRalms.item.confirm_password}[和${login.title.form.password}相同]"),
  
  --------------/pserver/list.lsp------------
  ["pserver.summary.title"]             = "用户概览",
  ["pserver.title"]                     = "用户管理",
  ["pserver.query.title"]               = ref("用户${common.text.search}"),
  ["pserver.form.username"]             = ref("${login.title.form.username}"), ---引用
  ["pserver.form.username.placeholder"] = "登录名[6-12个英文字母(不区分大小写)或者数字]",
  ["pserver.form.password"]             = "登录密码",
  ["pserver.form.password.placeholder"] = "要求[可输入6-20个任意字符]",
  ["pserver.form.email"]                = "电子邮箱",
  ["pserver.form.email.placeholder"]    = "请输入正确的邮箱而且不能重复",
  ["pserver.form.olevel"]               = "VIP级别",
  ["pserver.form.olevel.placeholder"]   = "请输入[0-10]之间的整数,0表示免费用户,10代表VIP最高级",
  ["pserver.allowUsers.title"]          = "允许注册用户数",
  ["pserver.registerUsers.title"]       = "当前注册用户数",
  ["pserver.onlineUsers.title"]         = "当前在线用户数",
  ["pserver.overflowUsers.title"]       = "超出流量用户数",
  ["pserver.list.search.title"]         = "查询条件",
  ["pserver.list.username.title"]       = ref("${login.title.form.username}"),
  ["pserver.list.muti.placeholder"] = "可多个用&quot;,&quot;号分割",
  ["pserver.list.user.state"]           = "帐号状态",
  ["pserver.list.runout.state"]         = "流量状态",
  ["pserver.list.runout.state_yes"]     = "用尽",
  ["pserver.list.runout.state_no"]      = "尚有",
  ["pserver.list.time_from"]            = "时间起",
  ["pserver.list.time_to"]              = "至",
  ["pserver.list.certlevel.state_no"]   = "未认证",
  ["pserver.list.certlevel.state_yes"]  = "已认证",
  
  
  -----/pserver/control.lsp--------------
  ["pserver.control.title"]             = "用户控制",
  ["pserver.control.level_desc_0"]      = "当前是<b>%s</b>用户.",
  ["pserver.control.level_desc_1"]      = "%s&nbsp;&nbsp;距离到期日还有<b>%s天%s小时</b>.",
  ["pserver.control.reset_pass_prompt"] = "重置密码需要重置设备或者重新安装软件,要继续吗？",
  ["pserver.control.onlineinfo"]        = [[反馈时间:<b>${time_desc}</b><br>
                                            目前状态:<b>${online_desc}</b><br>
                                            剩余流量:<b>${dataleft}兆</b><br>
                                            版本号:<b>Ver${version}</b><br>
                                            操作系统:<b>${osname}</b><br>
                                            PeerID:<b>${peerid}</b><br>
                                            登录服务器:<b>${servername}</b>]],
  ["pserver.vip.ttlday"]                = "有效天数",
  ["pserver.new_password"]              = ref("${common.text.new}${common.text.password}"),
  ["pserver.new_eamil"]                 = ref("${common.text.new}Email"),
  ["pserver.control.userconfig"]        = "用户配置",
  ["NDL_P_CLIENT"]                      = ref("${common.app.name}服务"),
  ["NDL_P_CLIENTWEB"]                   = ref("${common.app.name}管理界面"),
  -----/pserver/onlineinfo.lsp
  ["pserver.onlineinfo.title"]          = "用户在线信息",
  
  --------------/pserver/add.lsp------------
  ["pserver.add.title"]                 = "添加用户",
  ["pserver.user.username"]             = ref("${login.title.form.username}"),
  ["pserver.user.password"]             = ref("${login.title.form.password}"),
  ["pserver.user.ttlday"]               = ref("VIP${pserver.vip.ttlday}"),
  ["pserver.user.type"]                 = "帐号类型",
  ["pserver.user.phone"]                = ref("${listRalms.item.phone}"),
  ["pserver.user.phone_placeholder"]    = ref("${listRalms.item.phone.placeholder}"),
  ["pserver.user.address"]              = "地址",
  ["pserver.user.realname"]             = ref("${listRalms.item.realName}"),
  ["pserver.user.email"]                = "电子邮件",
  ["pserver.user.certlevel"]            = "认证级别",
  ["pserver.user.locsid"]               = "登陆设定",
  ["pserver.user.oemid"]                = "OEM设定",
  ["pserver.user.qq"]                   = "QQ号码",
  ["pserver.user.macaddr"]              = "绑定MAC地址",
  ["pserver.user.memo"]                 = "备注",
  ["pserver.user.error1"]               = ref("VIP${pserver.vip.ttlday}不能超过您帐号${pserver.vip.ttlday}"),
  ----intelligence import dialog
  ["pserver.import.desc"]                = "智能导入",
  ["pserver.import.itype"]               = "类型",
  ["pserver.import.itype_1"]             = "淘宝地址",
  ["pserver.import.content"]             = "内容",
  ["pserver.import.content_placeholder"] ="输入导入的内容",
  ["pserver.import.button"]              = "导入",
    
  -------------/pserver/edit.lsp -------------------
  ["pserver.edit.title"]                =  "修改用户",
  ["pserver.edit.reload"]               = "重新加载",
  ----peer type(@see infinite.listPeerTypes() )
  ["peer.type.node_regular"]            = "客户端",
  ["peer.type.server_http_only"]        = "独立HTTP服务器",
  ["peer.type.server_offical_civil"]    = "官方普通服务器(BRIDEGED)",
  ["peer.type.server_offical_oversea"]  = "官方独立海外服务器",
  ["peer.type.server_private"]          = "私人普通服务器",
  ["peer.type.server_managed_private"]  = "私人托管服务器",
  ["peer.type.server_advance_private"]  = "私人高级服务器",
  
  
  ------------/pserver/levels.lsp
  ["pserver.levels.title"]                  = "用户级别",
  ["level.level.title"]                     = "级别",
  ["level.reconnectseconds.title"]          = "重连间隔(单位:秒)",
  ["level.ownerid.title"]                   = "所属服务器用户ID",
  ["level.highbandwidth.title"]             = "高速带宽(单位:M/秒)",
  ["level.lowbandwidth.title"]              = "低速带宽(单位:K/秒)",
  ["level.perdatalimit.title"]              = "高速流量限制(单位:M/天)",
  ["level.calcunit.title"]                  = "流量计算单位",
  ["level.concurrencies.title"]             = "并发数",
  ["level.services.title"]                  = "端口映射数",
  ["level.domains.title"]                   = "绑定域名数",
  ["level.privatebandwidth.title"]          = "客户端中继带宽(单位:K/秒)",
  ["level.clients.title"]                   = "客户端数",
  ["level.name.title"]                      = "级别名称",
  ["level.tservices.title"]                 = "连接服务数",
  ["level.accessclients.title"]             = "安全访问用户数",
  
  ------------------/pserver/server.lsp////////////
  ["pserver.server.title"]                  = "基本设置",
  ["pserver.server.sysdomain"]              = "系统分配域名",
  ["pserver.server.servername"]             = "服务器名称",
  ["pserver.server.domain"]                 = "绑定域名",  
  ["pserver.server.domain_placeholder"]     = "域名要泛解析CNAME到: ${sysdomain}.",
  ["pserver.server.type"]                   = "服务器类型",  
  ["pserver.server.httpBridgeUser"]         = "HTTP桥接用户ID",  
  ["pserver.server.httpproxyport"]          = "标准HTTP端口",    
  ["pserver.server.portStart"]              = "对外服务端口起", 
  ["pserver.server.portEnd"]                = "对外服务端口止", 
  ["pserver.server.desc"]                   = "服务端说明", 
  
 -------------------------------/pserver/macbind.lsp////////////////////
 ["pserver.macbind.title"]                  =  "硬件绑定",
 ["pserver.macbind.services"]               =  "提供服务",
 ["pserver.macbind.tservices"]              =  "连接服务",
 ["pserver.macbind.macaddr"]                =  "MAC地址",
 
  -------------/pserver/execute.lsp--------------
  ["pserver.execute.title"]             = "执行命令",
  ["pserver.execute_result.title"]      = "执行结果",
  
  -----register.lsp
  ["register.info.success"]             = "恭喜你,注册成功,请登录!",
  
  ----------------tservices--------------
  -------listTServices.lsp----------------------
  ["listTServices.title"]                =  ref("${listServices.title}"),
  --------editTServices.lsp----
  ["editTService.title"]                 =  "修改/添加连接",
  ["editTService.domain.title"]          =  "服务域名",
  ["editTService.domain.placeholder"]    =  "访问的域名(对方提供的服务自动生成的域名,例如:a12345.nidaili.net)",
  ["editTService.autostart.title"]       =  "自动启动",
  ["editTService.access_address.title"]  =  "访问地址",
  ["editTService.authorise.title"]       =  "授权访问",
  ["editTService.name.title"]            =  "名 称",
  ["editTService.name.placeholder"]      =  ref("${editService.service.name.placeholder}[可为空:从对方设置获得]"),
  
  ----------connectNidailiVPN.lsp--------------
  ["connectNidailiVPN.title"]                =  ref("和${common.text.otherside}${editService.service.vpn.setting.vlan}"),
  ["connectNidailiVPN.error.check_make_vlan"]="不满足条件,不能组网",
  ["connectNidailiVPN.error.network_changed"]="网络配置有变化",
  ["connectNidailiVPN.error.port_changed"]   ="服务端口有变化",
  ["connectNidailiVPN.error.proto_changed"]  ="协议有变化",
  ["connectNidailiVPN.error.user_changed"]   ="用户信息有变化",
  ["connectNidailiVPN.changelan_alert"]      ="网络已改变,需手动刷新 http://{0}:{1}/login.lsp",
  ["connectNidailiVPN.suggest.changed_lan"]  =ref("${nidailiVlan.lancheck.title}设置冲突,建议设置为:{0},要自动设置吗？"),
  ["connectNidailiVPN.status.no_vlan"]       ="尚未组网",
  ["connectNidailiVPN.status.need_re_vlan"]  ="需重新组网",
  ["connectNidailiVPN.status.already_vlan"]  ="已经作为服务器组网了",
  ["connectNidailiVPN.title.vpn_settings"]   ="组网路由设置",
  ["connectNidailiVPN.title.routetype"]      ="所有流量走VPN",
  ["connectNidailiVPN.title.coexist"]        ="多个服务共存",
  ["connectNidailiVPN.makevlan.again"]       ="重新组网",
  ----tserviceWinzard.lsp-----------------
  ["tserviceWinzard.title"]                  =  ref("连接${common.text.winzard}"),
  ["tserviceWinzard.error.no_data"]          = "没有服务可以连接.",
  ["tserviceWinzard.service_type"]           =  "选择连接方法",
  ["tserviceWinzard.service_type_1"]         =  ref("通过${common.app.name}帐号连接"),
  ["tserviceWinzard.service_type_2"]         =  ref("通过${common.app.name}${editTService.domain.title}连接"),
  ["tserviceWinzard.serviceid_types"]        =  {'默认','手动'},
  ["tserviceWinzard.serviceids_manu"]        =  "服务设置",
  ["tserviceWinzard.username.placeholder"]   =  "此帐号和密码由服务提供方提供,非安全访问,可以为空",
  ["tserviceWinzard.makevlan"]               =  "快速组网",
  ["tserviceWinzard.service_list"]           =  "连接服务设置",
  ["tserviceWinzard.error.delete_running"]   =  "服务在运行中,请停止后再删除.",
  ["tserviceWinzard.makevlan.not_support"]   =  "此环境不支持组网.",
  ["tserviceWinzard.makevlan.success"]       =  ref("${tserviceWinzard.makevlan}${common.text.operation.success}"),
  
  --------------ddns.lsp
  ["ddns.title"]                             =   "DDNS服务",
  ["ddns.title.2"]                           =   ref("${ddns.title}[动态域名解析]"),
  ["ddns.info1"]                             =   [[动态域名和其它同类软件一样,适合有外网IP(动态或者静态)的用户,通过配置端口映射进行外网访问,
                                                   例如ADSL拨号等用户,能随着你的外网IP改变而改变域名的解析地址。如果您想绑定自己的域名,请设置域名的CNAME记录为该动态域名。]],
  ["ddns.info2"]                             =   ref([[如果你不了解自己的网络情况,或者不能、也不会配置端口映射,
                                                       请使用<a href="/pages/services/listServices.lsp" data-ajax="false">${common.app.name}${common.text.service}</a>,
                                                       就可轻松把内网服务发布到外网,不需要设置任何端口映射或者防火墙。 ]]),
  ["ddns.info3"]                             =  [[<p> 您的动态域名为:<a href="#">${domain}</a></p>
                                                  <p> 绑定外网地址为:<span class="font-green"><b>${data}</b></span> 
                                                      地址不对?<a href="${common.link.offical.url}/service/suggest" target="_blank" data-ajax="false">告诉我们</a>。
                                                  </p>]],
  ["ddns.test_title"]                       =   ref("${ddns.title}连通性测试"),
  ["ddns.test_info1"]                       =   ref("<b>注意!!!</b>在开通前，请您先在自己的拨号路由器上增加一条NAT映射(仅做测试用，开通后可以删除)，把设备(运行${common.app.name})的一个<b>空闲端口</b>映射出去。"),
  ["ddns.test.type"]                        =   ref("${serviceWinzard.proto_type}"), -- 服务协议
  ["ddns.test.localport"]                   =   "本地端口",
  ["ddns.test.localport_placeholder"]       =   "例如:3456 3457 等任意空闲端口即可",
  ["ddns.test.remoteport"]                  =   "映射端口",
  ["ddns.test.remoteport_placeholder"]      =   "NAT映射外网端口,默认和本地端口相同",
  
  ---------adminProfile.lsp
  ["adminProfile.title"]                    = "账户信息",
  ["adminProfile.turn_lowspeed"]            = "低速中继",
  ["adminProfile.turn_highspeed"]           = "高速中继",
  ["adminProfile.contractinfo"]             = "联系信息",
  ["adminProfile.address"]                  = ref("联系${pserver.user.address}"),
  ["adminProfile.address.placeholder"]      = ref("联系${pserver.user.address}[可输入2-20个字符]"),
  ----about.lsp----
  ["about.title"]                           = "关于我们",
  ["updateinfo.title"]                      = ref("${common.text.version}${common.text.info}"  ),  ---版本信息
  ["webclient.version"]                     = ref("${common.text.manage}${common.text.version}:V${version} ${info}"),  ---管理版本
  ["service.version"]                       = ref("${common.text.service}${common.text.version}:V${version} ${info}"), ---服务版本
  ["update.notify.restart"]                 = "重启后更新生效",
  ["update.notify.no-update"]               = ref("无新${common.text.version}"),
  ["contact.title"]                         = "联系我们",
  ----onlineinfo.lsp
  ["common.data.flipswitch.onofflines"]     = {"离线","在线"},
  -------------oem.lsp-------------------
  ["oem.title"]                             = "OEM设置",
  ["oem.username"]                          = "用户帐号",
  ["oem.app_name"]                          = "系统名称",
  ["oem.link_logo_img"]                     = "Logo图片(320X117,PNG格式)",
  ["oem.link_icon_png"]                     = "PNG图标(32X32,PNG格式)",  
  ["oem.link_icon_ico"]                     = "ICO图标(32X32,ICO格式)",
  ["oem.about_info"]                        = "关于信息",
  ["oem.contact_info"]                      = "联系信息", 
  ["oem.link_offical_url"]                  = "官网链接",
  ["oem.link_help_url"]                     = "帮助链接",
  ["oem.link_download_url"]                 = "下载链接",
  ["oem.link_bbs"]                          = "论坛链接",
  ["oem.link_vip"]                          = "VIP服务",
  ["oem.link_faq"]                          = "常问问题",
  ["oem.upload_error"]                      = "上传OEM数据失败!",
  ["oem.testconfirm"]                       = "OEM设置成功,要立即生效吗?",
  ------------settings.lsp
  ["settings.title"]                        = "系统设置",
  ["settings.Webclient_listening_ports"]    = "管理端口",
  ["settings.Peer_port"]                    = "服务端口",
  ["settings.advance_setting"]              = "高级配置",
  ["settings.configname"]                   = "配置项",
  ["settings.configvalue"]                  = "配置值",
  ["settings.configtype"]                   = "配置类型",
  ["settings.types"]                        = {"管理","服务"},
  ["settings.getconfigure"]                 = "得到配置",
  ["settings.setconfigure"]                 = "设置配置",
  
  ---------router--------------------
  ---------reboot.lsp------------
  ["router.rstatus.title"]                  = "网络状态",
  ["router.wan.title"]                      = "WAN口设置",
  ["router.lan.title"]                      = "LAN口设置",
  ["router.reboot.title"]                   = "重启设置",
  ["router.reboot_now"]                     = "立即重启",
  ["router.reboot_enabled"]                 = ref("${editService.service.disabled.switch}"),
  ["router.env_notsupported"]               = "环境不支持!",
  ["router.wait_reboot"]                    = "请耐心等待5分钟再操作!",
  ----------wifi.lsp-----------
  ["router.wifi.title"]                     = "WIFI设置",
  ["router.wifi_disabled"]                  = ref("${common.text.disabled}"),
  ["router.wifi_ssid"]                      = ref("${common.text.name}"),
  ["router.wifi_key"]                       = ref("${common.text.password}"),
  ["wifi.disabled_flipswitch"]              = {"启用","禁用"},
  
  ----------------node 节点管理 --------------------
  ["menu.level0.node.title"]                = "服务节点",
  ["node.list.title"]                       = "节点管理",
  ["node.execute.title"]                    = ref("${pserver.execute.title}"),
  ["node.ip.title"]                         = "IP地址",
}


return M